/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSMachines implements AWSMachineInterface
type FakeAWSMachines struct {
	Fake *FakeInfrastructureV1beta2
	ns   string
}

var awsmachinesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Resource: "awsmachines"}

var awsmachinesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Kind: "AWSMachine"}

// Get takes name of the aWSMachine, and returns the corresponding aWSMachine object, and an error if there is any.
func (c *FakeAWSMachines) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(awsmachinesResource, c.ns, name), &v1beta2.AWSMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSMachine), err
}

// List takes label and field selectors, and returns the list of AWSMachines that match those selectors.
func (c *FakeAWSMachines) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSMachineList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(awsmachinesResource, awsmachinesKind, c.ns, opts), &v1beta2.AWSMachineList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta2.AWSMachineList{ListMeta: obj.(*v1beta2.AWSMachineList).ListMeta}
	for _, item := range obj.(*v1beta2.AWSMachineList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSMachines.
func (c *FakeAWSMachines) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(awsmachinesResource, c.ns, opts))

}

// Create takes the representation of a aWSMachine and creates it.  Returns the server's representation of the aWSMachine, and an error, if there is any.
func (c *FakeAWSMachines) Create(ctx context.Context, aWSMachine *v1beta2.AWSMachine, opts v1.CreateOptions) (result *v1beta2.AWSMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(awsmachinesResource, c.ns, aWSMachine), &v1beta2.AWSMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSMachine), err
}

// Update takes the representation of a aWSMachine and updates it. Returns the server's representation of the aWSMachine, and an error, if there is any.
func (c *FakeAWSMachines) Update(ctx context.Context, aWSMachine *v1beta2.AWSMachine, opts v1.UpdateOptions) (result *v1beta2.AWSMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(awsmachinesResource, c.ns, aWSMachine), &v1beta2.AWSMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSMachine), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAWSMachines) UpdateStatus(ctx context.Context, aWSMachine *v1beta2.AWSMachine, opts v1.UpdateOptions) (*v1beta2.AWSMachine, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(awsmachinesResource, "status", c.ns, aWSMachine), &v1beta2.AWSMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSMachine), err
}

// Delete takes name of the aWSMachine and deletes it. Returns an error if one occurs.
func (c *FakeAWSMachines) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(awsmachinesResource, c.ns, name, opts), &v1beta2.AWSMachine{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSMachines) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(awsmachinesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta2.AWSMachineList{})
	return err
}

// Patch applies the patch and returns the patched aWSMachine.
func (c *FakeAWSMachines) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(awsmachinesResource, c.ns, name, pt, data, subresources...), &v1beta2.AWSMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSMachine), err
}
